| BACKGAMMON for the TI-89/92+/Voyage 200
| Copyright (C) 2002-2004 Kevin Kofler
| See readme.txt for the license which applies to this program.
| Do NOT distribute modified versions of this program without my permission.

.section .rodata.MainMenu,"d"

.xdef MainMenu,MainMenuPedroM,MainMenuTitle,PedroMsmallmenu
MainMenu:

L.DisplayOffset: .word MainMenuTitle-MainMenu
L.Flags:         .word 0x11
L.TotalItems:    .word 4
L.Width:         .byte 0
L.Height:        .byte 0
L.MainItems:     .word 4
L.DynSize:       .word 0
L.RedefOffset:   .word 0
L.RedefItems:    .word 0

.long -1

L.main_entries:
.word 0x8001 | MT_TEXT|GM_1P
.word L.GM_1P_text-MainMenuTitle
.word 0x8002 | MT_TEXT|GM_2P
.word L.GM_2P_text-MainMenuTitle
.word 0x8003 | MT_TEXT|GM_LINKW
.word L.GM_LINKW_text-MainMenuTitle
.word 0x8004 | MT_TEXT|GM_LINKB
.word L.GM_LINKB_text-MainMenuTitle

.long -1

MainMenuTitle: .asciz "Backgammon - Select game mode"

MainMenuPedroM:
L.GM_1P_text: .asciz "1 Player (vs. Calc)"
L.GM_2P_text: .asciz "2 Players (Same Calc)"
L.GM_LINKW_text: .asciz "Link Play (White)"
L.GM_LINKB_text: .asciz "Link Play (Black)"

.section .text.PedroMsmallmenu,"x"

| short PedroMsmallmenu(unsigned short x asm("d0"),unsigned short y asm("d1"),
| unsigned short nbitem asm("d2"),char *txtlist asm("a0"),void *ptr asm("a1"));
PedroMsmallmenu:
| Search for RAM_CALL table
0: addq.l #2,%a1
cmp.l #0x4c00,(%a1)
bne.s 0b
| Get kernel::LibsExec
movea.l (0x1d-0x21)*4(%a1),%a1
| Call userlib::smallmenu through kernel::LibsExec
move.l #0x000c0000,-(%a7)
pea.l L.userlib(%pc)
jsr (%a1)
addq.l #8,%a7
| Check if an item was selected
tst.w %d2
beq.s 1f
clr.w %d0
1: rts

L.userlib: .asciz "userlib"
